2011-08-24  Atsushi Eno  <atsushi@ximian.com>

	ReturnValue in MessageDescription was missing when there was
	MessageContract.

2011-08-03  Atsushi Eno  <atsushieno@veritas-vos-liberabit.com>

	Fix build, merge some missing changes to MessagePartDescription.

2011-08-02  Atsushi Eno  <atsushi@ximian.com>

	part of fix bug #41. MessageParameterAttribute is considered for
	return value.

	Conflicts:

	mcs/class/System.ServiceModel/System.ServiceModel.Description/MessagePartDescription.cs

2011-07-27  Atsushi Eno  <atsushi@ximian.com>

	Fix wsdl import wrt element qname (!= type name).

2011-06-14  Atsushi Eno  <atsushi@ximian.com>

	Flush some ongoing changes for XmlSerializer support in svcutil.

2011-05-27  Atsushi Eno  <atsushi@ximian.com>

	Fill type info in MessagePartDescription from XmlSerializer-based
	wsdl importer.

	It still needs some fixes to import message elements.

2011-05-14  Atsushi Eno  <atsushi@ximian.com>

	Implement XmlSerializerMessageContractImporter, round 2.

	This time it is XmlSerializer-based, got it somewhat working.

2011-05-13  Atsushi Eno  <atsushi@ximian.com>

	Implement WsdlContractConversionContext, and ignore message
	importer for now.

2011-05-11  Atsushi Eno  <atsushi@ximian.com>

	Revert previous XmlSerializerMessageContractImporter
	implementation.

	XsdDataContractImporter is not XmlSerializer-based, while this
	class is.

2011-05-10  Atsushi Eno  <atsushi@ximian.com>

	Fix common issue in MetadataSet - call MoveToContent() while
	iterating nodes.

2011-05-10  Atsushi Eno  <atsushi@ximian.com>

	Add new MetadataSetTest and fix couple of minor issues.

2011-05-09  Atsushi Eno  <atsushi@ximian.com>

	ongoing XmlSerializerMessageContractImporter work.

	It is part of bugfix #670945.

2011-04-14  Atsushi Eno  <atsushi@ximian.com>

	ServiceKnownTypeAttribute.MethodName was used way different to
	lookup method.

2011-04-08  Atsushi Eno  <atsushi@ximian.com>

	Add XmlSerializerFormatAttribute support in mobile profiles.

	Unlike moonlight, XmlSerializer is in the framework lib (sys.xml),
	so we don't have to split them out to Sys.Xml.Serialization.dll.

2011-04-07  Atsushi Eno  <atsushi@ximian.com>

	Fix moonlight_raw build in Sys.Xml.Serialization.dll (NIE!)

2011-04-07  Atsushi Eno  <atsushi@ximian.com>

	DataContractSerializerOperationBehavior is done too. Fix
	moonlight_raw build.

2011-04-07  Atsushi Eno  <atsushi@ximian.com>

	Some XmlSerializerFormatAttribute and
	XmlSerializerOperationBehavior refactoring.

2011-04-01  Atsushi Eno  <atsushi@ximian.com>

	Less !NET_2_1/!MOONLIGHT to improve SL4 WCF compatibility.

2011-04-01  Atsushi Eno  <atsushi@ximian.com>

	Implement ConfigurationName support for ChannelFactory.

	It is required for MoonlightDrtViewer bugfixing.

2011-04-01  Peter Gerbrandt  <pg@viadux.de>

	Fix contract description for contracts with deep inheritance
	hierarchy.

2011-03-17  Atsushi Eno  <atsushi@ximian.com>

	Fix build; remove extra !NET_2_1.

2011-03-16  Atsushi Eno  <atsushi@ximian.com>

	Enable more behavior interface member in NET_2_1.

2011-03-16  Atsushi Eno  <atsushi@ximian.com>

	Enable more behaviors use in NET_2_1 land, toward WebHttpBinding.

2011-03-16  Atsushi Eno  <atsushi@ximian.com>

	Add endpoint behavior support in NET_2_1, which involved not a few
	additions.

2011-03-07  Peter Gerbrandt  <pg@viadux.de>

	Support for the same interface as service contract and as callback
	contract.

2011-02-17  Atsushi Eno  <atsushi@ximian.com>

	Only use non-null values in ServiceAuthorizationBehavior.

2011-02-16  Atsushi Eno  <atsushi@ximian.com>

	Operation interface methods also have ServiceKnownType attributes.

2011-02-15  Atsushi Eno  <atsushi@ximian.com>

	Async MessageContract pattern needs more sophisticated contract
	validity check.

	It totally killed discovery.

2011-02-15  Atsushi Eno  <atsushi@ximian.com>

	ServiceDescription.cs does not exist in moonlight, so move
	TypeExtension.

2011-02-15  Atsushi Eno  <atsushi@ximian.com>

	MessageHeaderDescription were not filled in message contract.
	Reject wrong contracts.

2011-02-03  Atsushi Eno  <atsushi@ximian.com>

	Now operations are collected per corresponding
	ContractDescription.

	This fixes naming of MessageDescription Action URI from its type.

2011-02-02  Atsushi Eno  <atsushi@ximian.com>

	Implement GetInheritedContracts(), towards bugfix #668089.

2010-11-10  Marek Habersack  <grendel@twistedcode.net>

	[wcf] .NET allows for service contract methods to be decorated
	only by Web{Get,Invoke}Attribute

	Usually WCF requires that each service method is marked with the
	OperationContract attribute with the exception of methods
	decorated with the Web{Get,Invoke}Attribute attributes which are
	defined in System.ServiceModel.Web. This patch adds a simple way
	to extend the ContractDescriptionGenerator in order to provide
	this functionality without circular dependency of
	System.ServiceModel on System.ServiceModel.Web. Several extenders
	can be registered with the description generator and they will be
	invoked in the registration order until any of them returns
	'true'. Extenders are passed a reference to the OperationContract
	attribute with which the current method is decorated - if the
	reference is null, the extender should create a default instance
	of the attribute so that the description generator considers the
	method as one to be included in the contract description.

2010-10-22  Atsushi Eno  <atsushi@ximian.com>

	It should not have to import all schema elements, but those only
	used by contracts.

2010-10-22  Atsushi Eno  <atsushi@ximian.com>

	Small refactoring on enumerating message schema element contents.

2010-10-21  Atsushi Eno  <atsushi@ximian.com>

	OnEndXxx() methods should not try to let void return to a local
	variable.

2010-10-21  Atsushi Eno  <atsushi@ximian.com>

	Void event should not have Result of type void.

2010-10-21  Atsushi Eno  <atsushi@ximian.com>

	Make generated type names unique.

2010-10-21  Atsushi Eno  <atsushi@ximian.com>

	Add #if NET_2_1 and SupportFaults member for Silverlight SlSvcUtil
	proxy.

2010-10-08  Atsushi Eno  <atsushi@ximian.com>

	Do not reject contract from the same method, could happen by a
	type with multiple service contracts within the typie hierarchy.

	For details, see:
	http://lists.ximian.com/pipermail/mono-devel-list/2010-September/035940.html

2010-09-30  Atsushi Eno  <atsushi@ximian.com>

	Add DataContractResolver stuff (dummy), and fix Id reference from
	inside the referenced object.

2010-09-16  Atsushi Eno  <atsushi@ximian.com>

	Contract is settable in 4.0.

2010-09-13  Atsushi Eno  <atsushi@ximian.com>

	implemented large parts of WCF standard endpoints and
	configuration support.

2010-09-10  Atsushi Eno  <atsushi@ximian.com>

	Remove USE_DATA_CONTRACT_IMPORTER conditional compilation flag.

2010-09-09  Atsushi Eno  <atsushi@ximian.com>

	It should not fail to generate client proxy generation for having
	two "IsRequest=false" messages (it is set only in
	ContractDescriptionGenerator).

2010-09-03  Atsushi Eno  <atsushi@ximian.com>

	Add some argument check. RemoteAddress could be null for callback
	client runtime channel.

2010-08-27  Atsushi Eno  <atsushi@ximian.com>

	Add IsSystemEndpoint property and treat system endpoints as
	non-service.

2010-08-25  Atsushi Eno  <atsushi@ximian.com>

	Avoid NRE when ServiceEndpoint neither have Binding nor Contract.

2010-08-13  Atsushi Eno  <atsushi@ximian.com>

	ChannelDispatcherBase could be non-ChannelDispatcher. In WCF
	Discovery such type actually seems to exist, so it's not
	theoretical anymore.

2010-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs, ServiceMetadataExtension.cs :
	  remove invalid comments.

2010-07-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDescription.cs : fill Name and Namespace. Remove extra code.

2010-07-19  Sebastien Pouliot  <sebastien@ximian.com>

	* ClientCredentials.cs: Fix NET_2_1 builds

2010-07-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : implement Clone() here too.

2010-07-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs : implement Clone().

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : Reduced not a few lines of code,
	  now that we know wsdl and help do not have to be differentiated,
	  this extension support can be a lot simpler.

2010-06-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : add Instance field for simplification.

2010-06-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : pass channel dispatcher for .ctor.

2010-06-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : use simple ChannelDispatcher.IsMex field.

2010-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : overwrite MessageVersion to use None.
	  (The only special case I found for ChannelDispatcher.MessageVersion.)

2010-06-04  Atsushi Enomoto  <atsushi@ximian.com>

	* OperationDescription.cs : add contract origin flags to identify
	  which operation should be used for client operations (and dispatch
	  too in the future).
	* MessageDescription.cs : add IsRequest flag to indicate if it is
	  for request or not.
	* ServiceContractGenerator.cs, ContractDescriptionGenerator.cs :
	  make use of above changes.
	* ContractDescription.cs : don't create extraneous ClientOperations
	  in irrelevant message direction.

2010-06-03  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : Now callback contract methods are
	  also reflected into OperationDescription as well as those from non-
	  callback contract. Callback methods have reverse MessageDirection,
	  so adjust them.
	* ContractDescription.cs, ServiceEndpoint.cs, TypedMessageConverter.cs :
	  A bit of renaming / reflect method call changes.

2010-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs : fill ClientOperation.Formatter here.
	  (It is hacky, see additional comment.)

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : raise an error if it failed to set
	  mex info. (Make it safer.)

2010-04-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : reflect DispatcherBuilder change.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fill FaultDescription action,
	  name and namespace as expected.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs : fill FaultContractInfos in ClientOperation.

2010-04-02  Atsushi Enomoto  <atsushi@ximian.com>

	* FaultDescription.cs : fill Action.
	* ContractDescriptionGenerator.cs : do not fill Faults from service
	  impl. method. Do this from contract method instead.
	* OperationDescription.cs : remove extra TODOs.

2010-03-24  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : compare "wsdl" parameter in case-
	  insensitive manner.

2010-03-19  Atsushi Enomoto  <atsushi@ximian.com>

	* HostedBindingBehavior.cs : remove unused class.

2010-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* WsdlExporter.cs : allow identical contract while exporting a set
	  of endpoints, while reject identical ones when calling
	  ExportEndpoint() individually.

2010-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataExchangeBindings.cs : use WSHttpBinding (it works if other
	  parts gets fixed).

2010-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs, WsdlExporter.cs :
	  implement ExportEndpoints() and use it.

2010-03-16  Jb Evain  <jbevain@novell.com>

	* ClientCredentials.cs, ContractDescription.cs,
	IEndpointBehavior.cs: use MOONLIGHT symbol to disambiguate
	MonoTouch and Moonlight code.

2010-03-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpointCollection.cs : those overrides are rather to check
	  null arguments, not to skip contract duplicates.

2010-03-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageDescription.cs : implement MessageName.

2010-03-11  Atsushi Enomoto  <atsushi@ximian.com>

	* BaseMessagesFormatter.cs : add internal OperationFormatter type
	  for moonlight/silverlight-sdk compatibility. It mostly wraps
	  the existing the return value by BaseMessagesFormatter.Create().
	* DispatchOperation.cs, ClientOperation.cs, EndpointDispatcher.cs:
	  use above new type.

2010-03-11  Atsushi Enomoto  <atsushi@ximian.com>

	* OperationDescription.cs, MessagePartDescription.cs,
	  MessageDescription.cs : add internal moonlight compat stuff.

2010-03-11  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlName.cs : new internal type for moonlight/SL SDK compatibility.

2010-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataResolver.cs : fix BeginResolve() overloads and use
	  arguments as expected in Resolve().

2010-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataExchangeClient.cs : add missing members and implement some.

2010-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* WsdlImporter.cs : handle soapAction in operation binding too.
	  Now it successfully generates proxy generation for Twitterlight:
	  http://twitterlight.claritycon.com/TwitterWebService.asmx?WSDL

2010-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  consider schemas in wsdl documents.

2010-02-22  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataExchangeClient.cs, MetadataExchangeBindings.cs:
	  support https.

2010-02-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : fix duplicate output.

2010-02-19  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  Pick correct elements to import. Not wrapper elements but each
	  parameter and return value elements.

2010-02-19  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  remove extra parameter passing.

2010-02-19  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : add missing #ifs.

2010-02-19  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs, MessagePartDescription.cs,
	  DataContractSerializerMessageContractImporter.cs :
	  add alternative implementation to use XsdDataContractImporter
	  instead of XmlSchemaImporter hack.

	  It requires -d:USE_DATA_CONTRACT_IMPORTER and not enabled yet, as
	  it breaks some WSDL imports (such as memorabilia.hardrock.com).

2010-02-11  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs : handle duration
	  and guid which s.w.svc does not handle. Fix part of bug #579011.

2010-02-09  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs,
	  ServiceContractGenerator.cs: ArrayOfXxx does not exist in the type
	  definition code. Use Xxx[] directly instead.

2010-02-08  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataBundle.cs, MetadataSet.cs : rename former to latter.

2010-02-04  Atsushi Enomoto  <atsushi@ximian.com>

	*  ClientCredentials.cs, ContractDescription.cs,
	  IEndpointBehavior.cs, IOperationBehavior.cs : add monotouch support
	  for client behavior.

2010-01-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : when Options.AsynchronousMethods is
	  specified, generate async methods *as well as* sync methods (i.e.
	  not exclusively).

	  In moonlight proxy generator (svcutil -moonlight) mode, sync
	  methods will be removed at svcutil itself.
	  This fix brings sync proxy methods back to monotouch.

2010-01-19  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceAuthorizationBehavior.cs : implement (it does almost
	  nothing though).

2010-01-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fill Operation.Faults.

2010-01-08  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fix GetCallbackContract() to
	  correctly retrieve ServiceContractAttribute from the service type,
	  not the callback type. This ended up to get the bug #567672 sample
	  working (but it will break at some stage as it involves some
	  non-implemented classes).

2009-12-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs :
	  EventArgs are not nested classes.
	  Result property of EventArgs is not IAsyncResult. It should be
	  pulled from EndXxx() method, not from BeginXxx().

2009-12-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs :
	  add support for EventBasedAsynchronousMethods (3.5 SP1 / 2.1).

2009-12-18  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : added a couple of FIXME comments.

2009-12-01  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : more SL3 changes.

2009-11-25  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : it is part of SL3 API, so adjusted for it.

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : channelDispatchers is keyed by URL,
	  so it might have been skipped when the URLs are the same for wsdl
	  and help. So, differentiate flags for mex and help, not to be
	  exclusive. This fixes random-ish EndpointNotFound for WSDLs.

2009-10-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : A few fixes for no-wsdl case: fix
	  wrong html template, and do not throw NRE for the lack of WsdlUrl.

2009-10-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : restructure internal channel property
	  so that http channels can cope with it.

2009-10-16  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : Handle all predefined mex bindings.
	  Use DispatcherBuilder directly. Add mex listener property to
	  distinguish the listener from http channel listeners later.

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : when serviceDebug and serviceMetadata
	  shares the same URL, both of them must be set, not being skipped.

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs, ServiceMetadataBehavior.cs,
	  ServiceMetadataExtension.cs : Now HelpPage is differentiated from
	  wsdl page. The help page now outputs correct URL (for WSDL).

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs, ServiceMetadataBehavior.cs,
	  ServiceMetadataExtension.cs : reduce extra args, static isn't
	  required here. Add FIXME comments.

2009-10-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : before fixing lots of wrong code,
	  add primitive help page support to make sure base_uri is bogus.

2009-10-01  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : fixed sync client generator that
	  incorrectly exited in the middle of proxy generator.

2009-09-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : when its url is requested without
	  any parameters, it simply returns the WSDL, not the help page.

2009-09-15  Atsushi Enomoto  <atsushi@ximian.com>

	* WebServiceHelper.cs : remove old code.

2009-09-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : reflect ServiceHostBase change.

2009-09-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs : help page enabling properties are true
	  by default (fix regressions).

2009-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : default action name is prepended
	  "urn:", and on the other hand do not add extra '/' in such case.

2009-09-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : end method lookup should be
	  done against the type that defines begin method.

2009-09-01  Atsushi Enomoto  <atsushi@ximian.com>

	* MustUnderstandBehavior.cs : fix build.

2009-09-01  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs, ClientViaBehavior.cs,
	  MustUnderstandBehavior.cs : implement most of the methods.

2009-08-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs:
	  some dependent changes to ServiceHostBase.

2009-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerOperationBehavior.cs : add missing members.

2009-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataExchangeClient.cs : add missing async methods.

2009-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* MetadataResolver.cs : added remaining methods.
	* MetadataExchangeClient.cs : a bit of required changes for above.

2009-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs, ServiceMetadataBehavior.cs :
	  add Binding properties. Properties are now auto.
	* ServiceMetadataExtension.cs : take Binding too to build dispatcher.

2009-08-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : removed ChannelBase proxy stuff,
	  which will be moved to svcutil source.
	  The targets for extension should be the interface, not the client
	  class.

2009-08-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs,
	  OperationContractGenerationContext.cs : support extensions i.e.
	  IServiceContractGenerationExtension and IOperation...(ditto) .

2009-08-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : first step to add moonlight-based
	  client proxy generator (it is not supported in 3.5. needs to be
	  enabled by some hook, such as reflection-based hack).

2009-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs : wcf & 2.1 is specially annoying land :(

2009-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : add new contract getter to
	  create callback contract type (which does not demand
	  ServiceContractAttribute).

2009-08-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpoint.cs, ContractDescription.cs : moved client runtime
	  creator from former to latter.

2009-08-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpoint.cs : follow ClientRuntime change.

2009-07-31  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpoint.cs : ListenUri defaults to Address.Uri.

2009-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : actually it had to fill all of
	  the interface methods (and implementation methods).

2009-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : do not reject derived service
	  contract from another service contract type.

2009-06-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : implement Validate() (nothing to do
	  here).

2009-06-09  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : implement.

2009-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fill ProtectionLevel by
	  OperationContractAttribute.

2009-05-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs : IServiceBehavior.Validate() should not
	  throw NIE. No check so far.

2009-03-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageBodyDescription.cs, MessagePartDescription.cs,
	  OperationDescription.cs, MessageDescriptionCollection.cs:
	  clean up extra todos.

2009-03-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fill service known types.

2009-02-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : ClientBase<> argument type must be
	  class (the class itself is to be fixed soon as well).

2009-02-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpoint.cs : moved CreateRuntime() from ChannelFactory<T>.

2009-02-12  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : do not write body wrapper element
	  when IsWrapped = false.

2009-02-04  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : add async operation support (might
	  be hacky under some condition).

2009-01-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : async begin method with
	  [MessageContract] has 3 parameters, not 1.

2009-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  for such an element that does not contain schema type but has a
	  type reference, use ImportSchemaType().

2009-01-21  Atsushi Enomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  some refactoring. Process all schemas, including those in WSDLs.

2009-01-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs : fix by corcompare.

2008-05-28  Noam Lampert <noaml@mainsoft.com>
	* ContractDescriptionGenerator.cs: Allow services to implement more than one contract.
	  
2008-05-22  Noam Lampert <noaml@mainsoft.com>
	* ServiceDebugBehavior.cs: Correctly propagate IncludeExceptionDetailsInFaults. Previous code
	  overwrote values set in ServiceBehaviorAttribute.
	  
2008-05-22  Roei Erez  <roeie@mainsoft.com>
	* fix ContractDescription.GetContract implementation
	* Refactor Request processing
	* Add support for message inspectors
	* Add support for InstanceContextProvider & InstanceProvider, including lifecycles events
	like: ReleaseServiceInstance, Open, Close...
	* Add relevant test cases.

2008-05-01  Eyal Alaluf <eyala@mainsoft.com>

	* ContractDescriptionGenerator.cs: Support specifying custom names of
	  operations, actions, parameters and return value via attributes.

2008-04-21  Igor Zelmanovich <igorz@mainsoft.com>

	* ServiceDebugBehavior.cs: implement ApplyDispatchBehavior.
	* ServiceMetadataBehavior.cs: fix ApplyDispatchBehavior.
	* ServiceMetadataExtension.cs: refactoring, serves both 
	ServiceDebugBehavior and ServiceMetadataBehavior by providing suitable 
	functionality.		

2008-04-21  Igor Zelmanovich <igorz@mainsoft.com>

	* WsdlExporter.cs: fix ExportEndpoint: SoapBinding.Style is initialized 
	with SoapBindingStyle.Document value. 

2008-04-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ServiceEndpoint.cs: fixed Name property

2008-04-10  Eyal Alaluf <eyala@mainsoft.com>

	* TypedMessageConverter.cs: Simplified to use XmlMessagesFormatter and
	  DataContractMessagesFormatter that handle the actual message
	  serialization/deserialization.
	  Added support for XmlSerializaerFormat serialization.
	* ContractDescriptionGenerator.cs: Refactored to expose utilities for
	  creating MessageDescription from types for TypedMessageConverter use.
	* ServiceModelInternalConverter.cs: Removed.

2008-04-08  Roei Erez <roeie@mainsoft.com>

	* ServiceAuthorizationBehavior.cs:
	  -- remove throwing NotImplementedException and add MonoTODO
	* ServiceDebugBehavior.cs
	  -- remove throwing NotImplementedException and add MonoTODO
	* ServiceEndpoint.cs
	  -- Add validate method.
	* ServiceMetadataBehavior.cs
	  -- remove throwing NotImplementedException and add MonoTODO
	
2008-03-24  Igor Zelmanovich <igorz@mainsoft.com>

	* PolicyVersion.cs: imפlement ToString method, fix Namespace property.
	* ServiceTimeoutsBehavior.cs: add internal class behavior corresponds
	ServiceTimeoutsElement.

2008-03-23  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ContractDescriptionGenerator.cs: fixed GetMessage, fixed namespace
	while creating message part

2008-03-04  Eyal Alaluf <eyala@mainsoft.com>

	* ContractDescriptionGenerator.cs: Init ConfigurationName from attribute.

2008-02-27  Eyal Alaluf <eyala@mainsoft.com>

	* MetadataSectionSerializerBase.cs WSTrustMessageConverters.cs:
	  Fix compilation warnings.

2008-02-16  Atsushi Enomoto  <atsushi@ximian.com>

	* CallbackDebugBehavior.cs : new class.

2008-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : When reflecting a method,
	  iterate attributes and added such attribute that implements
	  IOperationBehavior to operation's Behaviors.

2007-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TypedMessageConverter.cs, ServiceModelInternalConverter.cs,
	  ContractDescriptionGenerator.cs : significant rewrite for
	  message serialization and deserialization. Proxy types are not
	  created anymore. Instead, serializers are created for every
	  message member. (Deserialization had been broken due to missing
	  default constructor of the proxy type.)

2007-08-16  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceModelInternalConverter.cs : use MessagePartDescription.Name
	  instead of MemberInfo.Name.

2007-08-16  Atsushi Enomoto  <atsushi@ximian.com>

	* TypedMessageConverter.cs ServiceModelInternalConverter.cs
	  ContractDescriptionGenerator.cs :
	  support MessageContractAttribute wrapper name specification and
	  non-wrapping outputs.

2007-07-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : reverted previous change. It is
	  conceptually wrong. RegisterInfo serialization is still possible
	  because it could contain private DataContract member which works
	  as a proxy to get or set properties on the RegisterInfo itself.

2007-07-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : added hack to support
	  [MessageContract] type which has no [MessageBody] member.

2007-03-30  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs : write prefixes.

2007-03-27  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustMessageConverters.cs, WSTrustSTSContract.cs:
	  now they could be used for both TLS and SPNego.

2007-03-20  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustMessageConverters.cs : fixed incorrect empty element check.
	* WSTrustSTSContract.cs :
	  Fixed Lifetime content namespace. Write KeySize.

2007-03-20  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs, WSTrustMessageConverters.cs :
	  process RequestedProofToken as raw TLS 1.0 application data, which
	  is likely a shared key.

2007-03-19  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs : support t:Authenticator output in RSTR.

2007-03-13  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs, WSTrustMessageConverters.cs :
	  (This inidividual commit breaks the build.)
	  Support all xml contents required for Sslnego RSTR collection.

2007-03-08  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs, WSTrustMessageConverters.cs :
	  Added IssueReply() operation to support RSTR from client.
	  Several fixes to read and write RSTR correctly.

2007-03-07  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs :
	  DispatchRuntime.InternalEndpointDispatcher was eliminated.

2007-03-05  Atsushi Enomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs, WSTrustMessageConverters.cs :
	  added missing support for token negotiation (WS-Trust section 10.3).

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs : oops.

2007-01-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs, ServiceCredentials.cs : Clone() throws
	  NotImplementedException when it returns an instance of different
	  type.

2006-12-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceMetadataExtension.cs : raising an NIE than returning null
	  is better (at least it avoids extra debugging).

2006-12-04  Atsushi Emomoto  <atsushi@ximian.com>

	* WsdlExporter.cs : Binding.MessageVersion could be null.

2006-12-04  Atsushi Emomoto  <atsushi@ximian.com>

	* DataContractSerializerMessageContractImporter.cs :
	  The latest XmlSchemaImporter.ImportTypeMapping() correctly reports
	  an error for xs:* primitive type argument. So it should not do
	  that as well.

2006-12-04  Atsushi Emomoto  <atsushi@ximian.com>

	* MetadataSectionSerializerBase.cs : Build fix.
	  It was based on old 2.0 beta API

2006-10-18  Ankit Jain  <jankit@novell.com>

	* ServiceMetadataBehavior.cs (AddBindingParameters): Add endpoint for
	HTTP GET requests.
	(ApplyDispatchBehavior): Move code to add *InstanceContextProviders to ..
	* ServiceMetadataExtension.cs (ServiceMetadataExtension.Attach): .. here.
	(HttpGetWsdl): Service HTTP GET requests like ?wsdl.

2006-10-17  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportEndpoint): Don't emit Soap* if
	MessageVersion.None
	(ExportService): Likewise.

2006-10-13  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportContract): Move code to .. 
	(ExportContractInternal): .. this. Add support for IWsdlExportExtension.
	(ExportEndpoint): Add support for IWsdlExportExtension.
	(ExportService): Return Port.
	* DataContractSerializerOperationBehavior.cs : Add IWsdlExportExtension
	interface.

2006-10-12  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs : added Http[s]Help properties.

2006-10-04  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs : do nothing in ApplyDispatchBehavior().

2006-10-04  Atsushi Emomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : reject async begin method whose
	  name does not begin with "Begin". (It even applies to operations
	  which has OperationContractAttribute with an explicit name(!).)

2006-10-04  Ankit Jain  <jankit@novell.com>

	* ServiceAuthorizationBehavior.cs (ApplyDispatchBehavior): Remove NYI
	exception.
	* ServiceMetadataBehavior.cs (ApplyDispatchBehavior): Instantiate and add a
	ServiceMetadataExtension to service host's extensions. Also, set the
	InstanceContextProvider for endpoints with IMetadataExchange contract
	to MexInstanceContextProvider.
	* ServiceMetadataExtension.cs (Metadata): Add internal 'set'.

2006-10-04  Atsushi Emomoto  <atsushi@ximian.com>

	* OperationDescriptionCollection.cs,
	  ContractDescriptionGenerator.cs : operation names must not conflict
	  each other.

2006-10-04  Ankit Jain  <jankit@novell.com>

	* ServiceContractGenerator.cs (GenerateProxyClass): Make .ctors public.

2006-10-03  Atsushi Emomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : EndBlah() must not be assigned an
	  OperationContractAttribute.

2006-09-22  Atsushi Emomoto  <atsushi@ximian.com>

	* LocalServiceSecuritySettings.cs : fix Clone().

2006-09-22  Atsushi Emomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : copy ProtectionLevel from attributes
	  to descriptions if required.

2006-09-22  Atsushi Emomoto  <atsushi@ximian.com>

	* FaultDescription.cs, MessageDescription.cs, ContractDescription.cs,
	  MessagePartDescription.cs, OperationDescription.cs :
	  Fixed HasProtectionLevel. It is always true when ProtectionLevel is set.

2006-09-18  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportEndpoint): Throw if endpoint.Binding is null.
	(ExportParameters):
	(ExportTypeMessage): Reprocess the schema.	

2006-09-08  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportParameters): Split into this and ..
	(ExportMessageBodyDescription): .. this.
	Check for duplicate message elements.
	(IsTypeMessage): Checks is a MessageBodyDescription has a single part of
	type System.ServiceModel.Channels.Message
	(ExportTypeMessage): Exports a complex type for type 
	System.ServiceModel.Channels.Message

2006-09-07  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportedContracts): New hashtable to keep track of
	the exported contracts.
	(ExportContract): Throw exception if contract has already been exported.

2006-09-07  Ankit Jain  <jankit@novell.com>

	* MetadataBundle.cs (MetadataSet.WriteTo): Remove WriteStartDocument
	as suggested by Atsushi.

2006-09-07  Ankit Jain  <jankit@novell.com>

	* MetadataBundle.cs (MetadataSet.WriteTo): Add WriteStartDocument.

2006-09-07  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportService): Export <service> and <port>.
	(GetService): New.
	(XsdExporter): New. Update code to use this instead of the 
	field, xsd_exporter.
	(schema_set): Remove.
	(GeneratedXmlSchemas): Use XsdExporter.Schemas directly.

2006-09-07  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportContract): Add 'imports'.

2006-09-07  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs : added missing members.

2006-09-06  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (ExportContract): Use String.Concat
	* ContractDescriptionGenerator.cs
	(ContractDescriptionGenerator.GetOperation): Set IsOneWay.
	* OperationDescription.cs (OperationDescription.IsOneWay): Add an
	internal setter.

2006-09-06  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (WsdlExporter.ExportEndpoint): Initial implementation.

2006-09-06  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceMetadataBehavior.cs : updated API to RC1.

2006-09-05  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (WsdlExporter.ExportContract): Add Namespaces.

2006-09-05  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceModelInternalConverter.cs : when a message part type is null
	  (such as void return value), supply dummy type (object).

2006-09-05  Ankit Jain  <jankit@novell.com>

	* MetadataBundle.cs (MetadataSet.WriteTo): Implement.
	* MetadataSectionSerializerBase.cs (WriteObject_ServiceDescription): Use
	ServiceDescription.Serializer to serialize.

2006-09-05  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs (WsdlExporter.AddImport): New.
	(WsdlExporter.GetSchemaElementForPart): Add 'schema' param.
	(WsdlExporter.ExportContract): Update to changes.

2006-09-05  Ankit Jain  <jankit@novell.com>

	* MetadataSection.cs (MetadataSection.CreateFromSchema): Implement.
	(MetadataSection.CreateFromServiceDescription): Implement.
	* WsdlExporter.cs (WsdlExporter.GetGeneratedMetadata): Update to use
	new methods above.

2006-09-04  Ankit Jain  <jankit@novell.com>

	* WsdlExporter.cs: Initial implementation for ExportContract.
	* MetadataExporter.cs (GetGeneratedMetadata): Fix signature.
	* ContractDescriptionGenerator.cs (GetMessage): Seperate Namespace and
	Name with "/" if its not there in Namespace.

2006-08-30  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceMetadataBehavior.cs : for now avoid NotImplementedException.
	* ServiceDebugBehavior.cs : implemented AddBindingParameters() and
	  ApplyDispatchBehavior().
	* ServiceCredentials.cs : implemented AddBindingParameters().

2006-08-28  Atsushi Emomoto  <atsushi@ximian.com>

	* WSTrustMessageConverters.cs : added response reader class.

2006-08-23  Atsushi Emomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs : rewritten to not use DataContract.
	* WSTrustMessageConverters.cs : new file.

2006-08-22  Atsushi Emomoto  <atsushi@ximian.com>

	* ClientCredentials.cs :
	  CloneCore() is virtual. CreateSecurityTokenManager() is public.
	* ServiceCredentials.cs :
	  Added secure conversation credential.
	  CreateSecurityTokenManager() is public.

2006-08-16  Atsushi Emomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs : added some more members in request type.
	  WST request and response types are renamed.

2006-08-14  Atsushi Emomoto  <atsushi@ximian.com>

	* WSTrustSTSContract.cs : added internal interface for security token
	  service (STS).

2006-08-11  Atsushi Emomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : implement CreateSecurityTokenManager() and
	  partly AddBindingParameters().
	* ServiceCredentials.cs : CreateSecurityTokenManager() as well.

2006-08-10  Atsushi Emomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : temporarily comment out NIE in 
	  ApplyClientBehavior().

2006-08-02  Atsushi Emomoto  <atsushi@ximian.com>

	* MetadataSectionSerializerBase.cs : made internal, namespace fix.

2006-07-31  Ankit Jain  <jankit@novell.com>

	* MetadataExchangeClient.cs (GetMetadataInternal): Use
	MessageHeaders.MessageId instead of manually adding the header.
	(SoapEnvelopeNamespace): Remove.
	(AddressingNamespace): Remove.

2006-07-28  Atsushi Emomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs :
	  added missing IssuedTokenAuthentication property.

2006-07-27  Ankit Jain  <jankit@novell.com>

	* DataContractSerializerMessageContractImporter.cs (resolveElement): Use
	XmlSchemaSet.Compile ()

2006-07-28  Atsushi Emomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : initialize SupportInteractive as true.

2006-07-28  Atsushi Emomoto  <atsushi@ximian.com>

	* LocalClientSecuritySettings.cs : moved to S.SM.Channels.

2006-07-27  Ankit Jain  <jankit@novell.com>

	* MessagePartDescription.cs (TypeName):
	(XmlTypeMapping): New, internal properties, used by
	ServiceContractGenerator.
	* DataContractSerializerMessageContractImporter.cs (ImportContract):
	Handle a void return type.
	(resolveElement):
	(resolveParticle): Use XmlSchemaImporter to fill in
	MessagePartDescription.XmlTypeMapping .
	(GetCLRTypeName): New.
	* ServiceContractGenerator.cs (.ctor): Set default options.
	(GenerateServiceContractType): Support ChannelInterface.	
	(GenerateProxyClass): Emit more .ctors
	(GenerateChannelInterface): New.
	(ExportInterface): Emit ServiceContractAttribute.Namespace property.
	(ExportParameters): New. Extract code for emitting methods params from
	AddOperationMethods & AddImplementationMethods.
	(ExportMessages): New. Emits method params using MessageDescriptionCollection.
	(ExportDataContract): New. Emits code for a DataContract from a XmlTypeMapping.
	(GetXmlNamespace): New. Gets the Namespace param of XmlTypeAttribute or
	XmlRootAttribute.

2006-07-27  Ankit Jain  <jankit@novell.com>

	* MetadataResolver.cs (ResolveContracts): Move the exception handling
	code for MetadataProxy.Get to .. 
	* MetadataExchangeClient.cs (GetMetadataInternal): .. here.

2006-07-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ClientCredentials.cs : July CTP API updates.

2006-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* PolicyConversionContext.cs : GetFaultBindingAssertions() argument:
	  MessageFault -> FaultDescription.

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* TypedMessageConverter.cs : implemented FromMessage() for
	  DataContract converter. Though it won't work right now.

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceModelInternalConverter.cs : It was bug #78855, and is fixed.
	* TypedMessageConverter.cs :
	  June CTP changed to write wrapper element.
	  Default URI is http://tempuri.org/, trailing '/' was missing.

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceModelInternalConverter.cs :
	  The runtime errors are still there...

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* IContractBehavior.cs : The API became sane in June CTP.
	* MatchAllEndpointBehavior.cs : vanished.

2006-07-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceModelInternalConverter.cs : assembly.Save() does not seem
	  to be required anymore. Maybe it was a runtime bug.

2006-07-13  Ankit Jain  <jankit@novell.com>

	* MetadataImporter.cs:
	* WsdlImporter.cs: 
	* DataContractSerializerMessageContractImporter.cs:
	* MetadataResolver.cs: Update to June CTP changes.

2006-07-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : fix async method handling. Since
	  begin methods return IAsyncResult, not the return value type, it
	  should not be used to generate MessagePartDescription.
	  OperationContractAttribute.ReplyAction should not be ignored.

2006-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* WebServiceHelper.cs : comment out the entire source (unused now).

2006-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* IMetadataExchange.cs : another unexpected change ;-)

2006-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* IMetadataExchange.cs : take back async methods.

2006-07-12  Ankit Jain  <jankit@novell.com>

	* MetadataTransferClient.cs: Renamed to .. 
	* MetadataExchangeClient.cs: .. this. Update to June CTP changes.
	(MetadataExchangeClient.MetadataProxy): Proxy for IMetadataExchange
	service contract.
	(MetadataExchangeClient.GetMetadataInternal): Move GetMetadata() code
	here. Updated to use MetadataProxy instead of doing everything manually.
	* MetadataSectionSerializerBase.cs: Regenerated for the updated API.
	* MetadataReference.cs: June CTP updates. Now implements
	IXmlSerializable.
	* MetadataResolver.cs: Update for related changes in other classes. June
	CTP updates pending.
	* MetadataExchangeBindings.cs
	(MetadataExchangeBindings.CreateMexHttpBinding): Implement.

2006-07-11  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceDebugBehavior.cs : new file.

2006-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : support AsyncPattern methods.

2006-07-07  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs, ServiceModelInternalConverter.cs :
	  renamed file from former to latter.

2006-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceContractGenerator.cs : in ClientBase, InnerProxy -> Channel.

2006-07-06  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs : exception type changed.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs :
	  MessageBodyAttribute -> MessageBodyMemberAttribute.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ReflectedContractCollection.cs : removed unused file.

2006-07-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs, ContractDescriptionGenerator.cs :
	  some June CTP updates (SessionMode).

2006-07-04  Atsushi Enomoto  <atsushi@ximian.com>

	* TypedMessageConverter.cs : June CTP update.

2006-07-04  Atsushi Enomoto  <atsushi@ximian.com>

	* ViaUriBehavior.cs : renamed to ClientViaBehavior.
	  File name is also being changed.

2006-07-03  Ankit Jain  <jankit@novell.com>

	* WsdlImporter.cs:
	* MetadataImporter.cs: Update for changes in other files. (June CTP)

2006-07-03  Ankit Jain  <jankit@novell.com>

	* XmlSerializerMessageContractConverter.cs: Renaming type to ..
	* XmlSerializerMessageContractImporter.cs: .. this.
	* DataContractSerializerMessageContractConverter.cs: Renaming type to ..
	* DataContractSerializerMessageContractImporter.cs: .. this.
	* IOperationContractGenerator.cs: Renaming to ..
	* IOperationContractGenerationExtension.cs: .. this.
	* IServiceContractGenerator.cs: Renaming to ..
	* IServiceContractGenerationExtension.cs: .. this.

	* DataContractSerializerOperationBehavior.cs:
	* MetadataResolver.cs:
	* MetadataSection.cs: Update to June CTP changes.

	* WsdlImporter.cs:
	* ServiceContractGenerator.cs: Update for changes in other files.

	* IMetadataExchange.cs: New.
	* MetadataExchangeBindings.cs: New.

2006-06-22  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs : in MessageBodyToDataContractType(),
	  support ReturnValue part as well.

2006-06-22  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : extracted public method
	  GetOperationContractAttribute() from existing code.

2006-06-20  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs : renaming type to 
	  ServiceModelInternalConverter as well as methods. Now it holds
	  conversion from MessageBodyDescription to DataContract Type.
	* TypedMessageConverter.cs : dependent changes from above.
	* ContractDescriptionGenerator.cs :
	  Temporarily commented out lines that rejects service contract
	  that does not contain any operation contracts.
	  Some refactoring.

2006-06-16  Ankit Jain  <jankit@novell.com>

	* MetadataSectionSerializerBase.cs: Remove debug Console.WriteLine-s.
	* WsdlImporter.cs: Streamline .ctors
	* MetadataImporter.cs: Likewise.
	* MetadataResolver.cs (MetadataResolver.Resolve): Update to use
	WSTransferGet instead of WsTransferGet.

2006-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs, TypedMessageConverter.cs :
	  Now it generates correct code, still emitting extra assemblies...

2006-06-12  Atsushi Enomoto  <atsushi@ximian.com>

	* MessageContractConverter.cs :
	  Now it generates code (which is incorrect), spitting dummy.dll
	  everywhere you run code that uses TypedMessageConverter...

2006-06-12 Ankit Jain  <jankit@novell.com>

	* MetadataSectionSerializerBase.cs: New.
	* MetadataBundle.cs (MetadataSet.ReadFrom): Use XmlSerializer for
	deserializing.
	(MetadataSet.ReadXml): Use MetadataSectionSerializer to deserialize
	MetadataSection-s.

	* MetadataImporter.cs (MetadataImporter..ctor): Use a predefined list of
	IPolicyImportExtensions if none is specified.
	* WsdlImporter.cs (WsdlImporter.ImportAllContracts): Cache the imported contracts.
	(WsdlImporter.ImportAllEndpoints): Implement.
	(WsdlImporter.ImportEndpoint): Likewise.
	(WsdlImporter..ctor): Use a predefined list of IWsdlImportExtentions if
	none is specified.
	* IWsdlImporter.cs (ImportContract):
	(ImportEndpoint): Fix param names.
	* WsdlEndpointConversionContext.cs: Update .ctor, and implement
	properties.

	* ServiceContractGenerator.cs: Update to not depend on
	contractDescription.ContractType as it can be null.
	* DataContractSerializerMessageContractConverter.cs (.resolveParticle):
	Add 'depth' param.

2006-06-12  Atsushi Enomoto  <atsushi@ximian.com>
	* TypedMessageConverter.cs, MessageContractConverter.cs :
	  ongoing implementation using Mono.CodeGeneration.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceCredentials.cs, ClientCredentials.cs,
	  ServiceMetadataBehavior.cs : moved from Sys.SvcModel.

2006-05-29  Atsushi Enomoto  <atsushi@ximian.com>

	* TypedMessageConverter.cs : some ToMessage() code.
	* MessageContractConverter.cs,
	* ContractDescriptionGenerator.cs : some code to generate contract 
	  type from an arbitrary Type.

2006-04-27  Ankit Jain  <jankit@novell.com>

	* WsdlImporter.cs:
	* DataContractSerializerMessageContractConverter.cs:
	* MetadataImporter.cs:
	* WsdlContractConversionContext.cs: Change member field names from
	camelCase to underscore_names.

2006-04-26  Ankit Jain  <jankit@novell.com>

	* MetadataBundle.cs (MetadataSet.ReadFrom): Initial implementation.
	(MetadataSet.Attributes): Add missing property.
	* MetadataReference.cs: Fix to match Feb CTP.
	* MetadataResolver.cs: Likewise.
	* MetadataSection.cs: Likewise.

	* MetadataImporter.cs (PolicyExtensions): Implement property.
	* MetadataTransferClient.cs (GetMetadata): Initial implementation.
	* WsdlImporter.cs: Initial implementation.

	* OperationDescription.cs (.ctor): Set is_initiating = true.
	* MessageDescription.cs (.ctor): 'action' parameter can be null or
	zero-length.
	* MessageBodyDescription.cs (Parts): Add internal set method.

	* WsdlContractConversionContext.cs (Contract): Implement property.
	(WsdlPortType): Likewise.
	* DataContractSerializerMessageContractConverter.cs (ImportContract):
	Initial implementation.

	* WebServiceHelper.cs: Copied from
	mcs/class/System.Web.Services/System.Web.Services.Protocols
	
2006-04-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : it is internal.
	* ServiceContractGenerator.cs : minimum implementation for
	  GenerateServiceContractType() for "client-proxy-gen" tool.

2006-04-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : reject operation-less contract.

2006-04-05  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescriptionGenerator.cs : The target contract type should be
	  the interface, not the implementation type.

2006-03-17  Atsushi Enomoto  <atsushi@ximian.com>

	* ContractDescription.cs : extracted GetContract() implementation
	  part into ContractDescriptionGenerator.cs.
	* ContractDescriptionGenerator.cs : new file.

2006-03-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceEndpointCollection.cs WsdlImporter.cs
	  PolicyConversionContext.cs OperationDescriptionCollection.cs
	  PolicyAssertionCollection.cs MessageDescriptionCollection.cs :
	  couple of API fixes.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* PeerSecurityBehavior.cs ServiceCredentials.cs
	  ServiceAuthorizationBehavior.cs :
	  Dependent fixes for System.IdentityModel reorgainzation.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* EndpointBehaviorCollection.cs ChannelDescription.cs
	  MessageHeaderDescriptionCollection.cs ServiceCredentials.cs
	  FaultDescription.cs TypedMessageConverter.cs
	  AspNetIntegrationRequirementsAttribute.cs
	  MessageDescription.cs MessagePartDescriptionCollection.cs
	  OperationBehaviorCollection.cs ListenUriBehavior.cs
	  ServiceAuthorizationBehavior.cs ChannelBehaviorCollection.cs
	  MessageBodyDescription.cs IContractBehavior.cs
	  MessagePropertyDescriptionCollection.cs
	  ContractBehaviorCollection.cs BehaviorCollection.cs
	  ServiceEndpointCollection.cs ContractDescription.cs
	  XmlFormatterOperationBehavior.cs FaultDescriptionCollection.cs
	  ServiceSecurityAuditBehavior.cs IChannelBehavior.cs
	  ServiceDescription.cs OperationBehaviorAttribute.cs
	  MatchAllEndpointBehavior.cs IEndpointBehavior.cs
	  ServiceMetadataBehavior.cs XmlSerializerOperationBehavior.cs
	  ServiceBehaviorCollection.cs HostedBindingBehavior.cs
	  MessageHeaderDescription.cs ViaUriBehavior.cs
	  MessagePartDescription.cs OperationDescriptionCollection.cs
	  IServiceBehavior.cs IOperationBehavior.cs
	  MessagePropertyDescription.cs MustUnderstandBehavior.cs
	  ServiceEndpoint.cs PeerSecurityBehavior.cs
	  OperationDescription.cs MessageDescriptionCollection.cs
	  ReflectedContractCollection.cs :
	  moved from System.ServiceModel due to the API changes.

2006-02-23  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs ContractExportBehavior.cs
	  IMessageEncodingBindingElement.cs IOperationContractGenerator.cs
	  IPolicyImporter.cs IServiceContractGenerator.cs
	  IStreamUpgradeBindingElement.cs ITransportTokenAssertionProvider.cs
	  IWsdlExporter.cs IWsdlImporter.cs InvalidChannelBindingException.cs
	  IpolicyExporter.cs MessageEncodingBindingElementConverter.cs
	  MetadataConversionError.cs MetadataExporter.cs MetadataImporter.cs
	  MetadataResolver.cs OperationContractGenerationContext.cs
	  PolicyConversionContext.cs ReliableSessionBindingElementConverter.cs
	  SecurityBindingElementConverter.cs
	  ServiceContractGenerationContext.cs ServiceContractGenerator.cs
	  ServiceThrottlingBehavior.cs
	  TransactionFlowBindingElementConverter.cs
	  TransportBindingElementConverter.cs WsdlContractConversionContext.cs
	  WsdlEndpointConversionContext.cs WsdlExporter.cs WsdlImporter.cs
	  XmlFormatterMessageContractConverter.cs
	  XmlSerializerMessageContractConverter.cs :
	  Feb. CTP API changes - chapter 1.

2006-02-14  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : ServiceThrottle was moved.

2006-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs :
	  All builder methods now "reset" UnhandledBindingElements after
	  the outermost processing.

2006-01-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs :
	  Use BindingElement's BuildBlahFactory directly. Implemented Clone().
	* ChannelLoader.cs : removed obsolete type.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* XmlSerializerMessageContractConverter.cs,
	  MessageEncodingBindingElementConverter.cs,
	  XmlFormatterMessageContractConverter.cs : new files in Nov. CTP.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceLoader.cs, TypeLoader.cs : removed.

2005-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs : IListener/-Factory vanished in Nov. CTP.

2005-11-20  Atsushi Enomoto  <atsushi@ximian.com>

	* IWsdlExporter.cs, InvalidChannelBindingException.cs,
	  MetadataImporter.cs, IWsdlImporter.cs, IPolicyImporter.cs,
	  MetadataConversionError.cs, IpolicyExporter.cs,
	  MetadataExporter.cs, PolicyConversionContext.cs :
	  New files in beta2
	* ITypeResolver.cs, WsdlBindingConversionContext.cs, 
	  IWsdlBindingElementConverter.cs,
	  WsdlOperationBindingCoversionContext.cs, 
	  WsdlMessageBindingConversionContext.cs,
	  WsdlMessageConversionContext.cs, IWsdlBindingConverter.cs,
	  IWsdlContractConverter.cs, IWsdlEndpointConverter.cs,
	  WsdlConversionContext.cs, WsdlConverters.cs,
	  InvalidSettingsException.cs, WsdlBindingConverterBase.cs,
	  WsdlConversionError.cs, CustomBindingConverter.cs, 
	  WsdlOperationConversionContext.cs :
	  Removed in beta2
	* ReliableSessionBindingElementConverter.cs, ServiceLoader.cs,
	  TransportBindingElementConverter.cs, ContractExportBehavior.cs,
	  ChannelLoader.cs, WsdlExporter.cs, MetadataResolver.cs,
	  SecurityBindingElementConverter.cs,
	  WsdlContractConversionContext.cs,
	  WsdlEndpointConversionContext.cs, WsdlImporter.cs,
	  ServiceThrottlingBehavior.cs, ServiceContractGenerator.cs,
	  TypeLoader.cs, TransactionFlowBindingElementConverter.cs :
	  Updated signatures to beta2.

2005-11-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs : was seeing
	  http://savas.parastatidis.name/2005/04/08/4b0b99b1-92c6-4442-ab2e-4c4951009ef4.aspx
	  and modified channel build logic a bit.

2005-10-31  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : implemented ApplyBehavior().

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs : added DequeueBindingElement() for
	  BindingElements' internal use. It becomes UnhandledBindingElements.

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs : implemented BuildListenerFactory().

2005-10-26  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs :
	  several API fixes detected by improved corcompare.

2005-10-25  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuildContext.cs : added missing generic class constraint.

2005-10-20  Atsushi Enomoto  <atsushi@ximian.com>

	* ReliableSessionBindingElementConverter.cs,
	  TransportBindingElementConverter.cs, ContractExportBehavior.cs,
	  SecurityBindingElementConverter.cs,
	  OperationContractGenerationContext.cs,
	  ServiceContractGenerationContext.cs, InvalidSettingsException.cs
	  WsdlBindingConverterBase.cs, WsdlConversionError.cs,
	  CustomBindingConverter.cs, ServiceContractGenerator.cs,
	  TransactionFlowBindingElementConverter.cs :
	  added all missing bits.
	* Dummy.cs : finally removed.
	* ServiceThrottlingBehavior.cs, WsdlBindingConversionContext.cs :
	  tiny API fix.

2005-10-13  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceLoader.cs : serviceType is moved to ServiceDescription.

2005-10-12  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceLoader.cs, TypeLoader.cs : implemented some.

2005-10-12  Atsushi Enomoto  <atsushi@ximian.com>

	* IWsdlEndpointConverter.cs, IOperationContractGenerator.cs,
	  IServiceContractGenerator.cs, WsdlBindingConversionContext.cs,
	  IWsdlBindingElementConverter.cs, IStreamUpgradeBindingElement.cs,
	  WsdlContractConversionContext.cs,
	  WsdlOperationBindingCoversionContext.cs,
	  WsdlMessageBindingConversionContext.cs,
	  WsdlEndpointConversionContext.cs, WsdlMessageConversionContext.cs,
	  IWsdlBindingConverter.cs, WsdlOperationConversionContext.cs,
	  IWsdlContractConverter.cs, ITransportTokenAssertionProvider.cs:
	  new files for wsdl importer.
	* Dummy.cs : removed above.
	* WsdlConversionContext.cs, IMessageEncodingBindingElement.cs :
	  tiny API fixes.

2005-10-11  Atsushi Enomoto  <atsushi@ximian.com>

	* IMessageEncodingBindingElement.cs : new file.
	* Dummy.cs : removed above.

2005-10-09  Atsushi Enomoto  <atsushi@ximian.com>

	* ChannelBuilderContext.cs : new file.
	* Dummy.cs : removed above.

2005-09-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ServiceThrottlingBehavior.cs : moved from sys.ServiceModel dir.

2005-09-28  Atsushi Enomoto  <atsushi@ximian.com>

	* ITypeResolver.cs, ChannelLoader.cs, ServiceLoader.cs,
	  TypeLoader.cs : new files.
	* Dummy.cs : removed those classes added above.
